<template>
  <div class="row list">
    <CCol
      v-for="box in data"
      :key="box.id"
      sm="2"
      class="item"
    >
      <CCard body-wrapper color="secondary" class="bg-gradient-secondary">
        <CCardHeader class="justify-content-center">
          <h3>{{ box.name }}</h3>
        </CCardHeader>

        <CCardBody>
          <div class="row">
            <div class="col-sm-8">
              商品数:
            </div>
            <div class="col-sm-4">
              {{ box.products.length }}
            </div>
          </div>

          <div class="row">
            <div class="col-sm-8">
              入札数:
            </div>
            <div class="col-sm-4">
              {{ box.bids.length }}
            </div>
          </div>

          <div class="row">
            <div class="col-sm-12">
              {{ formatDateTime(box.deadline) }}
            </div>
          </div>
        </CCardBody>

        <CCardFooter>
          <CInputCheckbox
            v-for="(item, index) in statusConfirm(box.status)"
            :key="index"
            :name="'status'"
            :label="item.name"
            :value="item.id"
            custom
            :checked="box.status === 1"
            @update:checked="(value, $event) => setChecked(value, $event, box)"
          />
        </CCardFooter>
      </CCard>
    </CCol>
  </div>
</template>

<script>
const EVENT_CHECKED = 'checked'
export default {
  props: {
    data: {
      type: Array,
      default: () => []
    }
  },

  methods: {

    /**
     * Format timestamp to MM/DD HH:MM
     *
     * @param {Number} timeStamp - date
     */
    formatDateTime (timeStamp) {
      return this.$moment(timeStamp).format('MM/DD HH:MM')
    },

    /**
     * Return status
     *
     * @param {Number} id - Confirmed or Unconfirmed
     */
    statusConfirm (id) {
      return [{ id, name: id === 1 ? '確認済み' : '未確認' }]
    },

    /**
     * V-model event
     * @param {Boolean} state
     * @param {Object} event
     * @param {Object} item
     */
    setChecked (state, event, item) {
      this.$emit(EVENT_CHECKED, item)
    }
  }

}
</script>
